-- pzr.adb
-- zadania cykliczne
-- Materiały dydaktyczne
-- Jacek Piwowarczyk 2021

with Ada.Exceptions;
use Ada.Exceptions;

package body Pzr is

  protected body Ekran is
    procedure Pisz(S : String) is
    begin
      Put_Line(S);
    end Pisz;
  end Ekran;

  task body T1 is
    Nastepny : Ada.Real_Time.Time;
    Okres : constant Ada.Real_Time.Time_Span := Ada.Real_Time.Milliseconds(800);
    Przesuniecie : constant Ada.Real_Time.Time_Span := Ada.Real_Time.Milliseconds(10);
  begin
    Nastepny := Ada.Real_Time.Clock + Przesuniecie;
    loop
      delay until Nastepny;
      Ekran.Pisz("Zadanie 1");
      Nastepny := Nastepny + Okres;
	  exit when Koniec;
    end loop;
	Ekran.Pisz("** Koncze zadanie T1 !");
  exception
      when E:others => Put_Line("Error: Zadanie T1");
        Put_Line(Exception_Name (E) & ": " & Exception_Message (E));
  end T1;

  task body T2 is
    Nastepny : Ada.Real_Time.Time;
    Okres : constant Ada.Real_Time.Time_Span := Ada.Real_Time.Milliseconds(800);
    Przesuniecie : constant Ada.Real_Time.Time_Span := Ada.Real_Time.Milliseconds(40);
  begin
    Nastepny := Clock + Przesuniecie;
    loop
      delay until Nastepny;
      Ekran.Pisz("Zadanie 2");
      Nastepny := Nastepny + Okres;
	  exit when Koniec;
    end loop;
	Ekran.Pisz("** Koncze zadanie T2 !");
	exception
      when E:others => Put_Line("Error: Zadanie T2");
        Put_Line(Exception_Name (E) & ": " & Exception_Message (E));
  end T2;

end Pzr;
